#include<bits/stdc++.h>
using namespace std;

const long long MAXN=100001;
long long n;
long long s1[MAXN],s2[MAXN],t1[MAXN],t2[MAXN];
long long Ans=0;
int main()
{
	//freopen("edit.in","r",stdin);
	//freopen("edit.out","w",stdout);
	
	int T;
	bool A=true;//性质A:s1的所有字符相同
	int jilu;
	
	cin>>T;
	for(int j=0;j<T;j++)
	{
		memset(s1,0,sizeof(s1));
		memset(s2,0,sizeof(s2));
		memset(t1,0,sizeof(t1));
		memset(t2,0,sizeof(t2));
		cin>>n;
		for(long long i=0;i<n;i++)
		{
			cin>>s1[i];
			if(i>=1)
			{
				if(jilu!=s1[i])
					A=false;//s1中不是所有字符都相等 
			}
			else
				jilu=s1[i];
		}
		for(long long i=0;i<n;i++)
		{
			cin>>s2[i];
			if(A==true)//性质A成立 
			{
				if(s2[i]==s1[0])
					Ans++;
			}
		}
		for(long long i=0;i<n;i++)
		{
			cin>>t1[i];
		}
		for(long long i=0;i<n;i++)
		{
			cin>>t2[i];
		}
		if(A==true)//性质A成立
		{
			cout<<Ans<<endl;
			Ans=0;
			A=true;//初始化 
		}
	}
	return 0;
}

